diff --git a/gcc/config/frv/frv.c b/gcc/config/frv/frv.c
index f2dadc3..c1f1c70 100644
--- a/gcc/config/frv/frv.c
+++ b/gcc/config/frv/frv.c
@@ -541,7 +541,7 @@ frv_small_data_reloc_p (rtx symbol, int reloc)
 {
   return (GET_CODE (symbol) == SYMBOL_REF
 	  && SYMBOL_REF_SMALL_P (symbol)
-	  && (!TARGET_FDPIC || flag_pic == 1)
+	  && (!TARGET_FDPIC || GCC_OPTION (flag_pic) == 1)
 	  && (reloc == R_FRV_GOTOFF12 || reloc == R_FRV_GPREL12));
 }
 
@@ -570,7 +570,7 @@ frv_const_unspec_p (rtx x, struct frv_unspec *unspec)
 
 	  if (frv_small_data_reloc_p (unspec->symbol, unspec->reloc)
 	      && unspec->offset > 0
-	      && unspec->offset < g_switch_value)
+	      && unspec->offset < GCC_OPTION (g_switch_value))
 	    return true;
 	}
     }
@@ -606,7 +606,7 @@ frv_cannot_force_const_mem (enum machine_mode mode ATTRIBUTE_UNUSED,
 static int
 frv_default_flags_for_cpu (void)
 {
-  switch (frv_cpu_type)
+  switch (GCC_OPTION (frv_cpu_type))
     {
     case FRV_CPU_GENERIC:
       return MASK_DEFAULT_FRV;
@@ -642,18 +642,18 @@ frv_option_override (void)
   int regno;
   unsigned int i;
 
-  target_flags |= (frv_default_flags_for_cpu () & ~target_flags_explicit);
+  GCC_OPTION (target_flags) |= (frv_default_flags_for_cpu () & ~target_flags_explicit);
 
   /* -mlibrary-pic sets -fPIC and -G0 and also suppresses warnings from the
      linker about linking pic and non-pic code.  */
   if (TARGET_LIBPIC)
     {
-      if (!flag_pic)		/* -fPIC */
-	flag_pic = 2;
+      if (!GCC_OPTION (flag_pic))		/* -fPIC */
+	GCC_OPTION (flag_pic) = 2;
 
       if (!global_options_set.x_g_switch_value)	/* -G0 */
 	{
-	  g_switch_value = 0;
+	  GCC_OPTION (g_switch_value) = 0;
 	}
     }
 
@@ -745,19 +745,19 @@ frv_option_override (void)
 
   /* Check for small data option */
   if (!global_options_set.x_g_switch_value && !TARGET_LIBPIC)
-    g_switch_value = SDATA_DEFAULT_SIZE;
+    GCC_OPTION (g_switch_value) = SDATA_DEFAULT_SIZE;
 
   /* There is no single unaligned SI op for PIC code.  Sometimes we
      need to use ".4byte" and sometimes we need to use ".picptr".
      See frv_assemble_integer for details.  */
-  if (flag_pic || TARGET_FDPIC)
+  if (GCC_OPTION (flag_pic) || TARGET_FDPIC)
     targetm.asm_out.unaligned_op.si = 0;
 
   if ((target_flags_explicit & MASK_LINKED_FP) == 0)
-    target_flags |= MASK_LINKED_FP;
+    GCC_OPTION (target_flags) |= MASK_LINKED_FP;
 
   if ((target_flags_explicit & MASK_OPTIMIZE_MEMBAR) == 0)
-    target_flags |= MASK_OPTIMIZE_MEMBAR;
+    GCC_OPTION (target_flags) |= MASK_OPTIMIZE_MEMBAR;
 
   for (i = 0; i < ARRAY_SIZE (frv_unit_names); i++)
     frv_unit_codes[i] = get_cpu_unit_code (frv_unit_names[i]);
@@ -831,10 +831,10 @@ frv_conditional_register_usage (void)
 
 #if 0
   /* If -fpic, SDA_BASE_REG is the PIC register.  */
-  if (g_switch_value == 0 && !flag_pic)
+  if (GCC_OPTION (g_switch_value) == 0 && !GCC_OPTION (flag_pic))
     fixed_regs[SDA_BASE_REG] = call_used_regs[SDA_BASE_REG] = 0;
 
-  if (!flag_pic)
+  if (!GCC_OPTION (flag_pic))
     fixed_regs[PIC_REGNO] = call_used_regs[PIC_REGNO] = 0;
 #endif
 }
@@ -1109,7 +1109,7 @@ frv_stack_info (void)
 	      if ((df_regs_ever_live_p (regno) && !call_used_regs[regno])
 		  || (crtl->calls_eh_return
 		      && (regno >= FIRST_EH_REGNUM && regno <= LAST_EH_REGNUM))
-		  || (!TARGET_FDPIC && flag_pic
+		  || (!TARGET_FDPIC && GCC_OPTION (flag_pic)
 		      && crtl->uses_pic_offset_table && regno == PIC_REGNO))
 		{
 		  info_ptr->save_p[regno] = REG_SAVE_1WORD;
@@ -1125,11 +1125,11 @@ frv_stack_info (void)
 
 	case STACK_REGS_LR:
 	  if (df_regs_ever_live_p (LR_REGNO)
-              || profile_flag
+              || GCC_OPTION (profile_flag)
 	      /* This is set for __builtin_return_address, etc.  */
 	      || cfun->machine->frame_needed
               || (TARGET_LINKED_FP && frame_pointer_needed)
-              || (!TARGET_FDPIC && flag_pic
+              || (!TARGET_FDPIC && GCC_OPTION (flag_pic)
 		  && crtl->uses_pic_offset_table))
 	    {
 	      info_ptr->save_p[LR_REGNO] = REG_SAVE_1WORD;
@@ -1757,10 +1757,10 @@ frv_expand_prologue (void)
   rtx fp = frame_pointer_rtx;
   frv_frame_accessor_t accessor;
 
-  if (TARGET_DEBUG_STACK)
+  if (GCC_OPTION (TARGET_DEBUG_STACK))
     frv_debug_stack (info);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = info->total_size;
 
   if (info->total_size == 0)
@@ -1853,7 +1853,7 @@ frv_expand_prologue (void)
     emit_insn (gen_blockage ());
 
   /* Set up pic register/small data register for this function.  */
-  if (!TARGET_FDPIC && flag_pic && crtl->uses_pic_offset_table)
+  if (!TARGET_FDPIC && GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table)
     emit_insn (gen_pic_prologue (gen_rtx_REG (Pmode, PIC_REGNO),
 				 gen_rtx_REG (Pmode, LR_REGNO),
 				 gen_rtx_REG (SImode, OFFSET_REGNO)));
@@ -1998,7 +1998,7 @@ frv_asm_output_mi_thunk (FILE *file,
       const char *name_pic = reg_names[FDPIC_REGNO];
       name_jmp = reg_names[FDPIC_FPTR_REGNO];
 
-      if (flag_pic != 1)
+      if (GCC_OPTION (flag_pic) != 1)
 	{
 	  fprintf (file, "\tsethi%s #gotofffuncdeschi(", parallel);
 	  assemble_name (file, name_func);
@@ -2017,7 +2017,7 @@ frv_asm_output_mi_thunk (FILE *file,
 	  fprintf (file, "\t)), %s\n", name_jmp);
 	}
     }
-  else if (!flag_pic)
+  else if (!GCC_OPTION (flag_pic))
     {
       fprintf (file, "\tsethi%s #hi(", parallel);
       assemble_name (file, name_func);
@@ -2081,10 +2081,10 @@ frv_frame_pointer_required (void)
   if (!crtl->sp_is_unchanging)
     return true;
 
-  if (!TARGET_FDPIC && flag_pic && crtl->uses_pic_offset_table)
+  if (!TARGET_FDPIC && GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table)
     return true;
 
-  if (profile_flag)
+  if (GCC_OPTION (profile_flag))
     return true;
 
   if (cfun->machine->frame_needed)
@@ -2130,7 +2130,7 @@ frv_initial_elimination_offset (int from, int to)
   else
     gcc_unreachable ();
 
-  if (TARGET_DEBUG_STACK)
+  if (GCC_OPTION (TARGET_DEBUG_STACK))
     fprintf (stderr, "Eliminate %s to %s by adding %d\n",
 	     reg_names [from], reg_names[to], ret);
 
@@ -2149,7 +2149,7 @@ frv_setup_incoming_varargs (cumulative_args_t cum_v,
 {
   CUMULATIVE_ARGS *cum = get_cumulative_args (cum_v);
 
-  if (TARGET_DEBUG_ARG)
+  if (GCC_OPTION (TARGET_DEBUG_ARG))
     fprintf (stderr,
 	     "setup_vararg: words = %2d, mode = %4s, pretend_size = %d, second_time = %d\n",
 	     *cum, GET_MODE_NAME (mode), *pretend_size, second_time);
@@ -2163,7 +2163,7 @@ frv_expand_builtin_saveregs (void)
 {
   int offset = UNITS_PER_WORD * FRV_NUM_ARG_REGS;
 
-  if (TARGET_DEBUG_ARG)
+  if (GCC_OPTION (TARGET_DEBUG_ARG))
     fprintf (stderr, "expand_builtin_saveregs: offset from ap = %d\n",
 	     offset);
 
@@ -2182,7 +2182,7 @@ frv_expand_builtin_va_start (tree valist, rtx nextarg)
   nextarg = gen_rtx_PLUS (Pmode, virtual_incoming_args_rtx,
 			  GEN_INT (UNITS_PER_WORD * num));
 
-  if (TARGET_DEBUG_ARG)
+  if (GCC_OPTION (TARGET_DEBUG_ARG))
     {
       fprintf (stderr, "va_start: args_info = %d, num = %d\n",
 	       crtl->args.info, num);
@@ -2680,7 +2680,7 @@ frv_print_operand_jump_hint (rtx insn)
     }
 
 #if 0
-  if (TARGET_DEBUG)
+  if (GCC_OPTION (TARGET_DEBUG))
     {
       char *direction;
 
@@ -3084,7 +3084,7 @@ frv_init_cumulative_args (CUMULATIVE_ARGS *cum,
 {
   *cum = FIRST_ARG_REGNUM;
 
-  if (TARGET_DEBUG_ARG)
+  if (GCC_OPTION (TARGET_DEBUG_ARG))
     {
       fprintf (stderr, "\ninit_cumulative_args:");
       if (!fndecl && fntype)
@@ -3166,7 +3166,7 @@ frv_function_arg_1 (cumulative_args_t cum_v, enum machine_mode mode,
       debstr = "memory";
     }
 
-  if (TARGET_DEBUG_ARG)
+  if (GCC_OPTION (TARGET_DEBUG_ARG))
     fprintf (stderr,
 	     "function_arg: words = %2d, mode = %4s, named = %d, size = %3d, arg = %s\n",
 	     arg_num, GET_MODE_NAME (mode), named, GET_MODE_SIZE (mode), debstr);
@@ -3213,7 +3213,7 @@ frv_function_arg_advance (cumulative_args_t cum_v,
 
   *cum = arg_num + words;
 
-  if (TARGET_DEBUG_ARG)
+  if (GCC_OPTION (TARGET_DEBUG_ARG))
     fprintf (stderr,
 	     "function_adv: words = %2d, mode = %4s, named = %d, size = %3d\n",
 	     arg_num, GET_MODE_NAME (mode), named, words * UNITS_PER_WORD);
@@ -3252,7 +3252,7 @@ frv_arg_partial_bytes (cumulative_args_t cum, enum machine_mode mode,
 	 : 0);
   ret *= UNITS_PER_WORD;
 
-  if (TARGET_DEBUG_ARG && ret)
+  if (GCC_OPTION (TARGET_DEBUG_ARG) && ret)
     fprintf (stderr, "frv_arg_partial_bytes: %d\n", ret);
 
   return ret;
@@ -3461,7 +3461,7 @@ frv_legitimate_address_p_1 (enum machine_mode mode,
       break;
     }
 
-  if (TARGET_DEBUG_ADDR)
+  if (GCC_OPTION (TARGET_DEBUG_ADDR))
     {
       fprintf (stderr, "\n========== legitimate_address_p, mode = %s, result = %d, addresses are %sstrict%s\n",
 	       GET_MODE_NAME (mode), ret, (strict_p) ? "" : "not ",
@@ -3488,7 +3488,7 @@ gen_inlined_tls_plt (rtx addr)
 
   dest = gen_reg_rtx (DImode);
 
-  if (flag_pic == 1)
+  if (GCC_OPTION (flag_pic) == 1)
     {
       /*
 	-fpic version:
@@ -3558,7 +3558,7 @@ frv_legitimize_tls_address (rtx addr, enum tls_model model)
   switch (model)
     {
     case TLS_MODEL_INITIAL_EXEC:
-      if (flag_pic == 1)
+      if (GCC_OPTION (flag_pic) == 1)
 	{
 	  /* -fpic version.
 	     ldi @(gr15, #gottlsoff12(x)), gr5
@@ -3677,13 +3677,13 @@ frv_local_funcdesc_p (rtx fnx)
     /* Private function descriptors for protected functions are not
        canonical.  Temporarily change the visibility to global.  */
     vis = VISIBILITY_DEFAULT;
-  else if (flag_shlib)
+  else if (GCC_OPTION (flag_shlib))
     /* If we're already compiling for a shared library (that, unlike
        executables, can't assume that the existence of a definition
        implies local binding), we can skip the re-testing.  */
     return TRUE;
 
-  ret = default_binds_local_p_1 (fn, flag_pic);
+  ret = default_binds_local_p_1 (fn, GCC_OPTION (flag_pic));
 
   DECL_VISIBILITY (fn) = vis;
 
@@ -3820,7 +3820,7 @@ frv_expand_fdpic_call (rtx *operands, bool ret_value, bool sibcall)
     {
       rtx x, dest;
       dest = gen_reg_rtx (SImode);
-      if (flag_pic != 1)
+      if (GCC_OPTION (flag_pic) != 1)
 	x = gen_symGOTOFF2reg_hilo (dest, addr, OUR_FDPIC_REG,
 				    GEN_INT (R_FRV_FUNCDESC_GOTOFF12));
       else
@@ -4060,7 +4060,7 @@ frv_emit_movsi (rtx dest, rtx src)
 	  else
 	    unspec = R_FRV_GOT12;
 	}
-      else if (flag_pic)
+      else if (GCC_OPTION (flag_pic))
 	base_regno = PIC_REGNO;
 
       break;
@@ -4120,7 +4120,7 @@ frv_emit_movsi (rtx dest, rtx src)
 		  case CONST:
 		  case SYMBOL_REF:
 		  case LABEL_REF:
-		    if (flag_pic)
+		    if (GCC_OPTION (flag_pic))
 		      {
 			unspec = R_FRV_GOTOFF12;
 			break;
@@ -4171,7 +4171,7 @@ frv_emit_movsi (rtx dest, rtx src)
       else if (SYMBOL_REF_SMALL_P (sym))
 	base_regno = SDA_BASE_REG;
 
-      else if (flag_pic)
+      else if (GCC_OPTION (flag_pic))
 	base_regno = PIC_REGNO;
 
       break;
@@ -4217,14 +4217,14 @@ frv_emit_movsi (rtx dest, rtx src)
 	    x = gen_symGPREL2reg (dest, src, OUR_FDPIC_REG, GEN_INT (unspec));
 	  break;
 	case R_FRV_FUNCDESC_GOTOFF12:
-	  if (flag_pic != 1)
+	  if (GCC_OPTION (flag_pic) != 1)
 	    x = gen_symGOTOFF2reg_hilo (dest, src, OUR_FDPIC_REG,
 					GEN_INT (unspec));
 	  else
 	    x = gen_symGOTOFF2reg (dest, src, OUR_FDPIC_REG, GEN_INT (unspec));
 	  break;
 	default:
-	  if (flag_pic != 1)
+	  if (GCC_OPTION (flag_pic) != 1)
 	    x = gen_symGOT2reg_hilo (dest, src, OUR_FDPIC_REG,
 				     GEN_INT (unspec));
 	  else
@@ -5253,7 +5253,7 @@ frv_ifcvt_add_insn (rtx pattern, rtx insn, int before_p)
   frv_ifcvt.added_insns_list = alloc_EXPR_LIST (VOIDmode, link,
 						frv_ifcvt.added_insns_list);
 
-  if (TARGET_DEBUG_COND_EXEC)
+  if (GCC_OPTION (TARGET_DEBUG_COND_EXEC))
     {
       fprintf (stderr,
 	       "\n:::::::::: frv_ifcvt_add_insn: add the following %s insn %d:\n",
@@ -5651,7 +5651,7 @@ frv_ifcvt_modify_multiple_tests (ce_if_block *ce_info,
   enum machine_mode mode = GET_MODE (true_expr);
   rtx (*logical_func)(rtx, rtx, rtx);
 
-  if (TARGET_DEBUG_COND_EXEC)
+  if (GCC_OPTION (TARGET_DEBUG_COND_EXEC))
     {
       fprintf (stderr,
 	       "\n:::::::::: frv_ifcvt_modify_multiple_tests, before modification for %s\ntrue insn:\n",
@@ -5726,7 +5726,7 @@ frv_ifcvt_modify_multiple_tests (ce_if_block *ce_info,
      inserted.  */
   frv_ifcvt_add_insn (check_insn, BB_END (bb), TRUE);
 
-  if (TARGET_DEBUG_COND_EXEC)
+  if (GCC_OPTION (TARGET_DEBUG_COND_EXEC))
     {
       fputs ("\n:::::::::: frv_ifcvt_modify_multiple_tests, after modification\ntrue insn:\n",
 	     stderr);
@@ -5749,7 +5749,7 @@ frv_ifcvt_modify_multiple_tests (ce_if_block *ce_info,
       *p_new_cr = NULL_RTX;
     }
 
-  if (TARGET_DEBUG_COND_EXEC)
+  if (GCC_OPTION (TARGET_DEBUG_COND_EXEC))
     fputs ("\n:::::::::: frv_ifcvt_modify_multiple_tests, failed.\n", stderr);
 
   return;
@@ -6150,7 +6150,7 @@ frv_ifcvt_modify_insn (ce_if_block *ce_info,
 	}
     }
 
-  if (TARGET_DEBUG_COND_EXEC)
+  if (GCC_OPTION (TARGET_DEBUG_COND_EXEC))
     {
       rtx orig_pattern = PATTERN (insn);
 
@@ -6166,7 +6166,7 @@ frv_ifcvt_modify_insn (ce_if_block *ce_info,
   return pattern;
 
  fail:
-  if (TARGET_DEBUG_COND_EXEC)
+  if (GCC_OPTION (TARGET_DEBUG_COND_EXEC))
     {
       rtx orig_pattern = PATTERN (insn);
 
@@ -6959,7 +6959,7 @@ frv_memory_move_cost (enum machine_mode mode ATTRIBUTE_UNUSED,
 static bool
 frv_assemble_integer (rtx value, unsigned int size, int aligned_p)
 {
-  if ((flag_pic || TARGET_FDPIC) && size == UNITS_PER_WORD)
+  if ((GCC_OPTION (flag_pic) || TARGET_FDPIC) && size == UNITS_PER_WORD)
     {
       if (GET_CODE (value) == CONST
 	  || GET_CODE (value) == SYMBOL_REF
@@ -7020,7 +7020,7 @@ frv_issue_rate (void)
   if (!TARGET_PACK)
     return 1;
 
-  switch (frv_cpu_type)
+  switch (GCC_OPTION (frv_cpu_type))
     {
     default:
     case FRV_CPU_FR300:
@@ -7066,7 +7066,7 @@ int
 frv_acc_group (rtx insn)
 {
   /* This distinction only applies to the FR550 packing constraints.  */
-  if (frv_cpu_type != FRV_CPU_FR550)
+  if (GCC_OPTION (frv_cpu_type) != FRV_CPU_FR550)
     return ACC_GROUP_NONE;
   return for_each_rtx (&PATTERN (insn), frv_acc_group_1, 0);
 }
@@ -7456,8 +7456,8 @@ frv_for_each_packet (void (*handle_packet) (void))
   frv_packet.issue_rate = frv_issue_rate ();
 
   /* Early exit if we don't want to pack insns.  */
-  if (!optimize
-      || !flag_schedule_insns_after_reload
+  if (!GCC_OPTION (optimize)
+      || !GCC_OPTION (flag_schedule_insns_after_reload)
       || !TARGET_VLIW_BRANCH
       || frv_packet.issue_rate == 1)
     return false;
@@ -7490,7 +7490,7 @@ frv_for_each_packet (void (*handle_packet) (void))
 
 	  default:
 	    /* Calls mustn't be packed on a TOMCAT.  */
-	    if (CALL_P (insn) && frv_cpu_type == FRV_CPU_TOMCAT)
+	    if (CALL_P (insn) && GCC_OPTION (frv_cpu_type) == FRV_CPU_TOMCAT)
 	      frv_finish_packet (handle_packet);
 
 	    /* Since the last instruction in a packet determines the EH
@@ -8194,7 +8194,7 @@ frv_register_nop (rtx nop)
 static void
 frv_reorg (void)
 {
-  if (optimize > 0 && TARGET_OPTIMIZE_MEMBAR && cfun->machine->has_membar_p)
+  if (GCC_OPTION (optimize) > 0 && TARGET_OPTIMIZE_MEMBAR && cfun->machine->has_membar_p)
     frv_optimize_membar ();
 
   frv_num_nops = 0;
@@ -9515,7 +9515,7 @@ frv_in_small_data_p (const_tree decl)
     }
 
   size = int_size_in_bytes (TREE_TYPE (decl));
-  if (size > 0 && size <= g_switch_value)
+  if (size > 0 && size <= GCC_OPTION (g_switch_value))
     return true;
 
   return false;
diff --git a/gcc/config/frv/frv.h b/gcc/config/frv/frv.h
index c936fd5..48cfa6b 100644
--- a/gcc/config/frv/frv.h
+++ b/gcc/config/frv/frv.h
@@ -150,7 +150,7 @@
       builtin_define_with_int_value ("__FRV_FPR__", NUM_FPRS);		\
       builtin_define_with_int_value ("__FRV_ACC__", NUM_ACCS);		\
 									\
-      switch (frv_cpu_type)						\
+      switch (GCC_OPTION (frv_cpu_type))						\
 	{								\
 	case FRV_CPU_GENERIC:						\
 	  builtin_define ("__CPU_GENERIC__");				\
@@ -183,7 +183,7 @@
 	builtin_define ("__FRV_DWORD__");				\
       if (TARGET_FDPIC)							\
 	builtin_define ("__FRV_FDPIC__");				\
-      if (flag_leading_underscore > 0)					\
+      if (GCC_OPTION (flag_leading_underscore) > 0)					\
 	builtin_define ("__FRV_UNDERSCORE__");				\
     }									\
   while (0)
@@ -199,7 +199,7 @@
 #define ACC_MASK						\
   (!TARGET_MEDIA ? 0						\
    : TARGET_ACC_4 ? 3						\
-   : frv_cpu_type == FRV_CPU_FR450 ? 11				\
+   : GCC_OPTION (frv_cpu_type) == FRV_CPU_FR450 ? 11				\
    : 7)
 
 /* Macros to identify the blend of media instructions available.  Revision 1
@@ -211,26 +211,26 @@
 
 #define TARGET_MEDIA_REV1					\
   (TARGET_MEDIA							\
-   && (frv_cpu_type == FRV_CPU_GENERIC				\
-       || frv_cpu_type == FRV_CPU_FR500))
+   && (GCC_OPTION (frv_cpu_type) == FRV_CPU_GENERIC				\
+       || GCC_OPTION (frv_cpu_type) == FRV_CPU_FR500))
 
 #define TARGET_MEDIA_REV2					\
   (TARGET_MEDIA							\
-   && (frv_cpu_type == FRV_CPU_FR400				\
-       || frv_cpu_type == FRV_CPU_FR405				\
-       || frv_cpu_type == FRV_CPU_FR450				\
-       || frv_cpu_type == FRV_CPU_FR550))
+   && (GCC_OPTION (frv_cpu_type) == FRV_CPU_FR400				\
+       || GCC_OPTION (frv_cpu_type) == FRV_CPU_FR405				\
+       || GCC_OPTION (frv_cpu_type) == FRV_CPU_FR450				\
+       || GCC_OPTION (frv_cpu_type) == FRV_CPU_FR550))
 
 #define TARGET_MEDIA_FR450					\
-  (frv_cpu_type == FRV_CPU_FR450)
+  (GCC_OPTION (frv_cpu_type) == FRV_CPU_FR450)
 
 #define TARGET_FR500_FR550_BUILTINS				\
-   (frv_cpu_type == FRV_CPU_FR500				\
-    || frv_cpu_type == FRV_CPU_FR550)
+   (GCC_OPTION (frv_cpu_type) == FRV_CPU_FR500				\
+    || GCC_OPTION (frv_cpu_type) == FRV_CPU_FR550)
 
 #define TARGET_FR405_BUILTINS					\
-  (frv_cpu_type == FRV_CPU_FR405				\
-   || frv_cpu_type == FRV_CPU_FR450)
+  (GCC_OPTION (frv_cpu_type) == FRV_CPU_FR405				\
+   || GCC_OPTION (frv_cpu_type) == FRV_CPU_FR450)
 
 #ifndef HAVE_AS_TLS
 #define HAVE_AS_TLS 0
@@ -409,7 +409,7 @@
 #define GPR_FP          (GPR_FIRST + 2)         /* Frame pointer */
 #define GPR_SP          (GPR_FIRST + 1)         /* Stack pointer */
 						/* small data register */
-#define SDA_BASE_REG    ((unsigned)(TARGET_FDPIC ? -1 : flag_pic ? PIC_REGNO : (GPR_FIRST + 16)))
+#define SDA_BASE_REG    ((unsigned)(TARGET_FDPIC ? -1 : GCC_OPTION (flag_pic) ? PIC_REGNO : (GPR_FIRST + 16)))
 #define PIC_REGNO       (GPR_FIRST + (TARGET_FDPIC?15:17))        /* PIC register.  */
 #define FDPIC_FPTR_REGNO  (GPR_FIRST + 14)        /* uClinux PIC function pointer register.  */
 #define FDPIC_REGNO   (GPR_FIRST + 15)        /* uClinux PIC register.  */
@@ -421,7 +421,7 @@
 #define FPR_FIRST       64			/* First FP reg */
 #define FPR_LAST        127			/* Last  FP reg */
 
-#define GPR_TEMP_NUM	frv_condexec_temps	/* # gprs to reserve for temps */
+#define GPR_TEMP_NUM	GCC_OPTION (frv_condexec_temps)	/* # gprs to reserve for temps */
 
 /* We reserve the last CR and CCR in each category to be used as a reload
    register to reload the CR/CCR registers.  This is a kludge.  */
@@ -1522,7 +1522,7 @@ __asm__("\n"								\
 
 /* A C expression for the cost of a branch instruction.  A value of 1 is the
    default; other values are interpreted relative to that.  */
-#define BRANCH_COST(speed_p, predictable_p) frv_branch_cost_int
+#define BRANCH_COST(speed_p, predictable_p) GCC_OPTION (frv_branch_cost_int)
 
 /* Define this macro as a C expression which is nonzero if accessing less than
    a word of memory (i.e. a `char' or a `short') is no faster than accessing a
@@ -1620,7 +1620,7 @@ do {									\
 } while (0)
 
 /* Whether to emit the gas specific dwarf2 line number support.  */
-#define DWARF2_ASM_LINE_DEBUG_INFO (TARGET_DEBUG_LOC)
+#define DWARF2_ASM_LINE_DEBUG_INFO (GCC_OPTION (TARGET_DEBUG_LOC))
 
 /* Output of Uninitialized Variables.  */
 
@@ -1651,7 +1651,7 @@ extern int size_directive_output;
 #undef ASM_OUTPUT_ALIGNED_DECL_LOCAL
 #define ASM_OUTPUT_ALIGNED_DECL_LOCAL(STREAM, DECL, NAME, SIZE, ALIGN)	\
 do {                                                                   	\
-  if ((SIZE) > 0 && (SIZE) <= (unsigned HOST_WIDE_INT) g_switch_value)	\
+  if ((SIZE) > 0 && (SIZE) <= (unsigned HOST_WIDE_INT) GCC_OPTION (g_switch_value))	\
     switch_to_section (get_named_section (NULL, ".sbss", 0));           \
   else                                                                 	\
     switch_to_section (bss_section);                                  	\
@@ -1813,7 +1813,7 @@ fprintf (STREAM, "\t.word .L%d-.L%d\n", VALUE, REL)
 #define ASM_OUTPUT_ADDR_VEC_ELT(STREAM, VALUE) \
 fprintf (STREAM, "\t.word .L%d\n", VALUE)
 
-#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)
+#define JUMP_TABLES_IN_TEXT_SECTION (GCC_OPTION (flag_pic))
 
 /* Assembler Commands for Exception Regions.  */
 
@@ -1937,7 +1937,7 @@ fprintf (STREAM, "\t.word .L%d\n", VALUE)
    conditional execution instructions instead of a branch.  A value of
    BRANCH_COST+1 is the default if the machine does not use
    cc0, and 1 if it does use cc0.  */
-#define MAX_CONDITIONAL_EXECUTE frv_condexec_insns
+#define MAX_CONDITIONAL_EXECUTE GCC_OPTION (frv_condexec_insns)
 
 /* A C expression to modify the code described by the conditional if
    information CE_INFO, possibly updating the tests in TRUE_EXPR, and
@@ -2001,7 +2001,7 @@ frv_ifcvt_modify_multiple_tests (CE_INFO, BB, &TRUE_EXPR, &FALSE_EXPR)
    the more tries will be made to choose better schedule.  If the
    macro value is zero or negative there will be no multi-pass
    scheduling.  */
-#define FIRST_CYCLE_MULTIPASS_SCHEDULING_LOOKAHEAD frv_sched_lookahead
+#define FIRST_CYCLE_MULTIPASS_SCHEDULING_LOOKAHEAD GCC_OPTION (frv_sched_lookahead)
 
 enum frv_builtins
 {
diff --git a/gcc/config/h8300/elf.h b/gcc/config/h8300/elf.h
index 97e844b..f3c0f61 100644
--- a/gcc/config/h8300/elf.h
+++ b/gcc/config/h8300/elf.h
@@ -36,7 +36,7 @@ along with GCC; see the file COPYING3.  If not see
 #undef USER_LABEL_PREFIX
 #define USER_LABEL_PREFIX "_"
 
-#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)
+#define JUMP_TABLES_IN_TEXT_SECTION (GCC_OPTION (flag_pic))
 
 #undef LINK_SPEC
 #define LINK_SPEC "%{mh:%{mn:-m h8300hnelf}} %{mh:%{!mn:-m h8300helf}} %{ms:%{mn:-m h8300snelf}} %{ms:%{!mn:-m h8300self}} %{msx:%{mn:-m h8300sxnelf;:-m h8300sxelf}}"
diff --git a/gcc/config/h8300/h8300.c b/gcc/config/h8300/h8300.c
index e7ed03a..6b0faa2 100644
--- a/gcc/config/h8300/h8300.c
+++ b/gcc/config/h8300/h8300.c
@@ -322,7 +322,7 @@ h8300_option_override (void)
   if (TARGET_H8300SX)
     {
       error ("-msx is not supported in coff");
-      target_flags |= MASK_H8300S;
+      GCC_OPTION (target_flags) |= MASK_H8300S;
     }
 #endif
 
@@ -344,31 +344,31 @@ h8300_option_override (void)
   if (!TARGET_H8300S && TARGET_MAC)
     {
       error ("-ms2600 is used without -ms");
-      target_flags |= MASK_H8300S_1;
+      GCC_OPTION (target_flags) |= MASK_H8300S_1;
     }
 
   if (TARGET_H8300 && TARGET_NORMAL_MODE)
     {
       error ("-mn is used without -mh or -ms or -msx");
-      target_flags ^= MASK_NORMAL_MODE;
+      GCC_OPTION (target_flags) ^= MASK_NORMAL_MODE;
     }
 
   if (! TARGET_H8300S &&  TARGET_EXR)
     {
       error ("-mexr is used without -ms");
-      target_flags |= MASK_H8300S_1;
+      GCC_OPTION (target_flags) |= MASK_H8300S_1;
     }
 
   if (TARGET_H8300 && TARGET_INT32)
    {
       error ("-mint32 is not supported for H8300 and H8300L targets");
-      target_flags ^= MASK_INT32;
+      GCC_OPTION (target_flags) ^= MASK_INT32;
    }
 
  if ((!TARGET_H8300S  &&  TARGET_EXR) && (!TARGET_H8300SX && TARGET_EXR))
    {
       error ("-mexr is used without -ms or -msx");
-      target_flags |= MASK_H8300S_1;
+      GCC_OPTION (target_flags) |= MASK_H8300S_1;
    }
 
  if ((!TARGET_H8300S  &&  TARGET_NEXR) && (!TARGET_H8300SX && TARGET_NEXR))
@@ -381,7 +381,7 @@ h8300_option_override (void)
      See http://gcc.gnu.org/ml/gcc-patches/2002-07/msg01858.html
      If optimizing for size, change shift_alg for those shift to
      SHIFT_LOOP.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     {
       /* H8/300 */
       shift_alg_hi[H8_300][SHIFT_ASHIFT][5] = SHIFT_LOOP;
@@ -418,7 +418,7 @@ h8300_option_override (void)
 	 h8sx instructions.  */
       h8300_move_ratio = 3;
     }
-  else if (flag_omit_frame_pointer)
+  else if (GCC_OPTION (flag_omit_frame_pointer))
     {
       /* movmd sequences are fairly cheap when er6 isn't fixed.  They can
 	 sometimes be as short as two individual memory-to-memory moves,
@@ -426,7 +426,7 @@ h8300_option_override (void)
 	 to allow up to three moves here.  */
       h8300_move_ratio = 4;
     }
-  else if (optimize_size)
+  else if (GCC_OPTION (optimize_size))
     {
       /* In this case we don't use movmd sequences since they tend
 	 to be longer than calls to memcpy().  Memory-to-memory
@@ -443,8 +443,8 @@ h8300_option_override (void)
     }
 
   /* This target defaults to strict volatile bitfields.  */
-  if (flag_strict_volatile_bitfields < 0 && abi_version_at_least(2))
-    flag_strict_volatile_bitfields = 1;
+  if (GCC_OPTION (flag_strict_volatile_bitfields) < 0 && abi_version_at_least(2))
+    GCC_OPTION (flag_strict_volatile_bitfields) = 1;
 }
 
 /* Return the byte register name for a register rtx X.  B should be 0
@@ -2006,7 +2006,7 @@ h8300_return_addr_rtx (int count, rtx frame)
   if (count == 0)
     ret = gen_rtx_MEM (Pmode,
 		       gen_rtx_REG (Pmode, RETURN_ADDRESS_POINTER_REGNUM));
-  else if (flag_omit_frame_pointer)
+  else if (GCC_OPTION (flag_omit_frame_pointer))
     return (rtx) 0;
   else
     ret = gen_rtx_MEM (Pmode,
@@ -2662,7 +2662,7 @@ bool
 h8sx_emit_movmd (rtx dest, rtx src, rtx length,
 		 HOST_WIDE_INT alignment)
 {
-  if (!flag_omit_frame_pointer && optimize_size)
+  if (!GCC_OPTION (flag_omit_frame_pointer) && GCC_OPTION (optimize_size))
     return false;
 
   if (GET_CODE (length) == CONST_INT)
@@ -5573,7 +5573,7 @@ output_simode_bld (int bild, rtx operands[])
 static void
 h8300_reorg (void)
 {
-  if (flag_delayed_branch)
+  if (GCC_OPTION (flag_delayed_branch))
     shorten_branches (get_insns ());
 }
 
diff --git a/gcc/config/i386/cygming.h b/gcc/config/i386/cygming.h
index 039edcc..438ba29 100644
--- a/gcc/config/i386/cygming.h
+++ b/gcc/config/i386/cygming.h
@@ -32,7 +32,7 @@ along with GCC; see the file COPYING3.  If not see
 #endif
 
 #undef TARGET_SEH
-#define TARGET_SEH  (TARGET_64BIT_MS_ABI && flag_unwind_tables)
+#define TARGET_SEH  (TARGET_64BIT_MS_ABI && GCC_OPTION (flag_unwind_tables))
 
 /* Win64 with SEH cannot represent DRAP stack frames.  Disable its use.
    Force the use of different mechanisms to allocate aligned local data.  */
@@ -78,7 +78,7 @@ along with GCC; see the file COPYING3.  If not see
 #undef DBX_REGISTER_NUMBER
 #define DBX_REGISTER_NUMBER(n)				\
   (TARGET_64BIT ? dbx64_register_map[n]			\
-   : (write_symbols == DWARF2_DEBUG			\
+   : (GCC_OPTION (write_symbols) == DWARF2_DEBUG			\
       ? svr4_dbx_register_map[n] : dbx_register_map[n]))
 
 /* Map gcc register number to DWARF 2 CFA column number. For 32 bit
@@ -198,19 +198,19 @@ along with GCC; see the file COPYING3.  If not see
 #undef  SUBTARGET_OVERRIDE_OPTIONS
 #define SUBTARGET_OVERRIDE_OPTIONS					\
 do {									\
-  if (TARGET_64BIT && flag_pic != 1)					\
+  if (TARGET_64BIT && GCC_OPTION (flag_pic) != 1)					\
     {									\
-      if (flag_pic > 1)							\
+      if (GCC_OPTION (flag_pic) > 1)							\
         warning (0,							\
 	         "-fPIC ignored for target (all code is position independent)"\
                  );                         				\
-      flag_pic = 1;							\
+      GCC_OPTION (flag_pic) = 1;							\
     }									\
-  else if (!TARGET_64BIT && flag_pic)					\
+  else if (!TARGET_64BIT && GCC_OPTION (flag_pic))					\
     {									\
       warning (0, "-f%s ignored for target (all code is position independent)",\
-	       (flag_pic > 1) ? "PIC" : "pic");				\
-      flag_pic = 0;							\
+	       (GCC_OPTION (flag_pic) > 1) ? "PIC" : "pic");				\
+      GCC_OPTION (flag_pic) = 0;							\
     }									\
 } while (0)
 
@@ -272,7 +272,7 @@ do {						\
 #define CHECK_STACK_LIMIT 4000
 
 #undef STACK_BOUNDARY
-#define STACK_BOUNDARY	(TARGET_64BIT && ix86_abi == MS_ABI ? 128 : BITS_PER_WORD)
+#define STACK_BOUNDARY	(TARGET_64BIT && GCC_OPTION (ix86_abi) == MS_ABI ? 128 : BITS_PER_WORD)
 
 /* By default, target has a 80387, uses IEEE compatible arithmetic,
    returns float values in the 387 and needs stack probes.
diff --git a/gcc/config/i386/darwin.h b/gcc/config/i386/darwin.h
index 5c9b073..7b188f4 100644
--- a/gcc/config/i386/darwin.h
+++ b/gcc/config/i386/darwin.h
@@ -69,7 +69,7 @@ extern int darwin_emit_branch_islands;
 /* For compatibility with OSX system tools, use the new style of pic stub
    if this is set.  */
 #undef  MACHOPIC_ATT_STUB
-#define MACHOPIC_ATT_STUB (darwin_macho_att_stub)
+#define MACHOPIC_ATT_STUB (GCC_OPTION (darwin_macho_att_stub))
 
 #undef MAX_BITS_PER_WORD
 #define MAX_BITS_PER_WORD 64
@@ -85,7 +85,7 @@ extern int darwin_emit_branch_islands;
    or dynamic loader.  */
 #undef STACK_BOUNDARY
 #define STACK_BOUNDARY \
- ((profile_flag || (TARGET_64BIT && ix86_abi == MS_ABI)) \
+ ((GCC_OPTION (profile_flag) || (TARGET_64BIT && GCC_OPTION (ix86_abi) == MS_ABI)) \
   ? 128 : BITS_PER_WORD)
 
 #undef MAIN_STACK_BOUNDARY
@@ -233,7 +233,7 @@ extern int darwin_emit_branch_islands;
 #define SUBTARGET_OVERRIDE_OPTIONS \
 do {									\
   if (TARGET_64BIT && MACHO_DYNAMIC_NO_PIC_P)				\
-    target_flags &= ~MASK_MACHO_DYNAMIC_NO_PIC;				\
+    GCC_OPTION (target_flags) &= ~MASK_MACHO_DYNAMIC_NO_PIC;				\
 } while (0)
 
 /* Darwin on x86_64 uses dwarf-2 by default.  Pre-darwin9 32-bit
@@ -249,13 +249,13 @@ do {									\
 #undef DBX_REGISTER_NUMBER
 #define DBX_REGISTER_NUMBER(n) 					\
   (TARGET_64BIT ? dbx64_register_map[n]				\
-   : write_symbols == DWARF2_DEBUG ? svr4_dbx_register_map[n]	\
+   : GCC_OPTION (write_symbols) == DWARF2_DEBUG ? svr4_dbx_register_map[n]	\
    : dbx_register_map[n])
 
 /* Unfortunately, the 32-bit EH information also doesn't use the standard
    DWARF register numbers.  */
 #define DWARF2_FRAME_REG_OUT(n, for_eh)					\
-  (! (for_eh) || write_symbols != DWARF2_DEBUG || TARGET_64BIT ? (n)	\
+  (! (for_eh) || GCC_OPTION (write_symbols) != DWARF2_DEBUG || TARGET_64BIT ? (n)	\
    : (n) == 5 ? 4							\
    : (n) == 4 ? 5							\
    : (n) >= 11 && (n) <= 18 ? (n) + 1					\
diff --git a/gcc/config/i386/djgpp.h b/gcc/config/i386/djgpp.h
index 6ddd833..d7f5897 100644
--- a/gcc/config/i386/djgpp.h
+++ b/gcc/config/i386/djgpp.h
@@ -166,7 +166,7 @@ along with GCC; see the file COPYING3.  If not see
 #define SUBTARGET_OVERRIDE_OPTIONS \
 do \
   { \
-    if (TARGET_BNU210) \
+    if (GCC_OPTION (TARGET_BNU210)) \
       {	\
         warning (0, "-mbnu210 is ignored (option is obsolete)"); \
       }	\
